local addonInfo, privateVars = ...

---------- init namespace ---------

if not EnKai then EnKai = {} end

if not EnKai.eventHandlers then EnKai.eventHandlers = {} end
if not EnKai.events then EnKai.events = {} end

local internal    = privateVars.internal
local data        = privateVars.data

---------- init local variables ---------

local _insecureEvents = {}

---------- local function block ---------

local function _fctProcessInsecure()

  if Inspect.System.Secure() == true then return end
  
  local remainingEvents = false
  
  for k, v in pairs(_insecureEvents) do
    if v ~= false then
      if v.timer == nil or v.period == nil then
        v.func()
        _insecureEvents[k] = false
      else
        if Inspect.Time.Frame() - v.timer > v.period then
          v.func()
          _insecureEvents[k] = false
        else
          remainingEvents = true
        end
      end
    end
  end 
  
  if remainingEvents == false then _insecureEvents = {} end

end

local function _fctUpdateHandler()

	internal.coroutinesProcess()
	internal.processFX()
	_fctProcessInsecure()
	internal.uiGarbageCollector()
	internal.processMap()
	internal.processCooldowns()
	internal.checkShard()

end

---------- library public function block ---------

function EnKai.events.addInsecure(func, timer, period)

  local uuid = EnKai.tools.uuid ()
	_insecureEvents[uuid] = {func = func, timer = timer, period = period }
	return uuid

end

function EnKai.events.removeInsecure(id) _insecureEvents[id] = false end

function EnKai.internal.checkEvents (name, init) -- radial muss umgebaut werden, dann kann diese function internal gemacht werden

	if EnKai.eventHandlers[name] == nil and init ~= false then
--	  if nkDebug then
--	    if EnKai.eventHandlers[name] == nil then print ("event handler for " .. name .. " is nil and init ~= false") end	    
--	  end 
		EnKai.eventHandlers[name] = {}
		EnKai.events[name] = {}
	elseif init ~= false then
		EnKai.tools.error.display (addonInfo.identifier, string.format("Duplicate name '%s' found!", name), 1)
		return false
	end
	
	return true

end

---------- addon internal function block ---------

function internal.deRegisterEvents (name)
  
  if EnKai.eventHandlers[name] ~= nil then
    EnKai.eventHandlers[name] = nil
    EnKai.events[name] = nil
  end

end

-------------------- EVENTS --------------------

Command.Event.Attach(Event.System.Update.Begin, _fctUpdateHandler, "EnKai.system.updateHandler")